<?php
/*
Plugin Name: Inline Upload
Plugin URI: http://www.iptanus.com/?page_id=27
Description: Simple interface to upload files from a page.
Version: 1.4
Author: Nickolas Bossinas
Author URI: http://www.iptanus.com
*/

/*
-------****** This plugin is a conversion of Upload Widget plugin of Monpelaud ******-------
*/

/*
Inline Upload (Wordpress Plugin)
Copyright (C) 2010 Nickolas Bossinas
Contact me at http://www.iptanus.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

//tell wordpress to register the plugin shortcode

add_shortcode("inline_upload", "inline_upload_handler");
load_plugin_textdomain('inline-upload', false, dirname(plugin_basename (__FILE__)).'/languages');
wp_enqueue_style('inline-upload-style', '/'.PLUGINDIR .'/'.dirname(plugin_basename (__FILE__)).'/css/inline_upload_style.css',false,'1.0','all');
wp_enqueue_script('httprequest_script', WP_CONTENT_URL.'/plugins/'.dirname(plugin_basename (__FILE__)).'/include/http_request.js');

//define plugin defaults
DEFINE("IU_UPLOADID", "1");
DEFINE("IU_UPLOADTITLE", __('Upload a file', 'inline-upload'));
DEFINE("IU_SELECTBUTTON", __('Select File', 'inline-upload'));
DEFINE("IU_UPLOADBUTTON", __('Upload File', 'inline-upload'));
DEFINE("IU_UPLOADROLE", "administrator");
DEFINE("IU_UPLOADPATH", 'uploads');
DEFINE("IU_CREATEPATH", "false");
DEFINE("IU_UPLOADPATTERNS", "*.*");
DEFINE("IU_MAXSIZE", "10");
DEFINE("IU_ACCESSMETHOD", "normal");
DEFINE("IU_FTPINFO", "");
DEFINE("IU_DUBLICATESPOLICY", "overwrite");
DEFINE("IU_UNIQUEPATTERN", "index");
DEFINE("IU_FILEBASELINK", "false");
DEFINE("IU_NOTIFY", "false");
DEFINE("IU_NOTIFYRECIPIENTS", "");
DEFINE("IU_NOTIFYSUBJECT", __('File Upload Notification', 'inline-upload'));
DEFINE("IU_NOTIFYMESSAGE", __("Dear Recipient,\n\n   This is an automatic delivery message to notify you that a new file has been uploaded.\n\nBest Regards", 'inline-upload'));
DEFINE("IU_ATTACHFILE", "false");
DEFINE("IU_REDIRECT", "false");
DEFINE("IU_REDIRECTLINK", "");
DEFINE("IU_ADMINMESSAGES", "false");
DEFINE("IU_SUCCESSMESSAGE", __('File %filename% uploaded successfully', 'inline-upload'));
DEFINE("IU_SUCCESSMESSAGECOLOR", "green");

function inline_upload_handler($incomingfrompost) {
  //process incoming attributes assigning defaults if required
  $incomingfrompost=shortcode_atts(array(
    "uploadid" => IU_UPLOADID,
    "uploadtitle" => IU_UPLOADTITLE,
    "selectbutton" => IU_SELECTBUTTON,
    "uploadbutton" => IU_UPLOADBUTTON,
    "uploadrole" => IU_UPLOADROLE,
    "uploadpath" => IU_UPLOADPATH,
    "createpath" => IU_CREATEPATH,            
    "uploadpatterns" => IU_UPLOADPATTERNS,
    "maxsize" => IU_MAXSIZE,            
    "accessmethod" => IU_ACCESSMETHOD,            
    "ftpinfo" => IU_FTPINFO,            
    "dublicatespolicy" => IU_DUBLICATESPOLICY,            
    "uniquepattern" => IU_UNIQUEPATTERN,            
    "filebaselink" => IU_FILEBASELINK,            
    "notify" => IU_NOTIFY,            
    "notifyrecipients" => IU_NOTIFYRECIPIENTS,            
    "notifysubject" => IU_NOTIFYSUBJECT,            
    "notifymessage" => IU_NOTIFYMESSAGE,            
    "attachfile" => IU_ATTACHFILE,            
    "redirect" => IU_REDIRECT,            
    "redirectlink" => IU_REDIRECTLINK,            
    "adminmessages" => IU_ADMINMESSAGES,            
    "successmessage" => IU_SUCCESSMESSAGE,            
    "successmessagecolor" => IU_SUCCESSMESSAGECOLOR            
  ), $incomingfrompost);
  //run function that actually does the work of the plugin
  $inline_upload_output = inline_upload_function($incomingfrompost);
  //send back text to replace shortcode in post
  return $inline_upload_output;
}

function upload_plugin_clean($label) {
	/**
	 * Regular expressions to the change some characters.
	 */

	$search = array ('@[éèêëÊË]@i','@[àâäÂÄ]@i','@[îïÎÏ]@i','@[ûùüÛÜ]@i','@[ôöÔÖ]@i',
	'@[ç]@i','@[^a-zA-Z0-9._]@');	 
	$replace = array ('e','a','i','u','o','c','-');
	$label =  preg_replace($search, $replace, $label);
	$label = strtolower($label); // Convert in lower case
	return $label;
}

function upload_plugin_full_path( $path ) {
	if ($path) {
		if ( substr($path, 0, 1) == "/" ) $path = substr($path, 1, strlen($path) - 1);
		if ( substr($path, -1, 1) == "/" ) $path = substr($path, 0, strlen($path) - 1);
		$full_upload_path = WP_CONTENT_DIR.'/'.$path.'/'; }
	else {
		$full_upload_path = WP_CONTENT_DIR.'/uploads/';
	}
	return $full_upload_path;
}

function upload_plugin_wildcard_to_preg($pattern) {
	return '/^' . str_replace(array('\*', '\?', '\[', '\]'), array('.*', '.', '[', ']+'), preg_quote($pattern)) . '$/is';
}



function upload_plugin_wildcard_match($pattern, $str) {
	$pattern = upload_plugin_wildcard_to_preg($pattern);
	return preg_match($pattern, $str);
}

function create_directory($path, $method, $ftpdata, $adminmessages) {
	if ( $method == "" || $method == "normal" ) {
		mkdir($path, 0777);
	}
	else if ( $method == "ftp" && $ftpdata != "" ) {
		$ftpdata_flat =  str_replace(array('\:', '\@'), array('\_', '\_'), $ftpdata);
		$pos1 = strpos($ftpdata_flat, ":");
		$pos2 = strpos($ftpdata_flat, "@");
		if ( $pos1 && $pos2 && $pos2 > $pos1 ) {
			$ftp_username = substr($ftpdata, 0, $pos1);
			$ftp_password = substr($ftpdata, $pos1 + 1, $pos2 - $pos1 - 1);
			$ftp_host = substr($ftpdata, $pos2 + 1);
			$conn_id = ftp_connect($ftp_host);
			$login_result = ftp_login($conn_id, $ftp_username, $ftp_password);
			if ( $conn_id && $login_result ) {
				$flat_host = preg_replace("/^(.*\.)?([^.]*\..*)$/", "$2", $ftp_host);
				$pos1 = strpos($path, $flat_host);
				if ( $pos1 ) {
					$path = substr($path, $pos1 + strlen($flat_host));
					ftp_mkdir($conn_id, $path);
					ftp_chmod($conn_id, 511, $path);
				}
				else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Could not resolve ftp target filedir. Check the domain in 'ftpinfo' attribute.", "inline-upload").'</strong></font>'; 
			}
			else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Invalid ftp information. Check 'ftpinfo' attribute.", "inline-upload").'</strong></font>';
			ftp_quit($conn_id);
		}
		else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Could not extract ftp information from 'ftpinfo' attribute. Check its syntax.", "inline-upload").'</strong></font>';
	}		
}


function upload_file($source, $target, $method, $ftpdata, $adminmessages) {
	if ( $method == "" || $method == "normal" ) {
		return copy($source, $target);
	}
	else if ( $method == "ftp" &&  $ftpdata != "" ) {
		$result = false;
		$ftpdata_flat =  str_replace(array('\:', '\@'), array('\_', '\_'), $ftpdata);
		$pos1 = strpos($ftpdata_flat, ":");
		$pos2 = strpos($ftpdata_flat, "@");
		if ( $pos1 && $pos2 && $pos2 > $pos1 ) {
			$ftp_username = substr($ftpdata, 0, $pos1);
			$ftp_password = substr($ftpdata, $pos1 + 1, $pos2 - $pos1 - 1);
			$ftp_host = substr($ftpdata, $pos2 + 1);
			$conn_id = ftp_connect($ftp_host);
			$login_result = ftp_login($conn_id, $ftp_username, $ftp_password);
			if ( $conn_id && $login_result ) {
				$flat_host = preg_replace("/^(.*\.)?([^.]*\..*)$/", "$2", $ftp_host);
				$pos1 = strpos($target, $flat_host);
				if ( $pos1 ) {
					$temp_fname = tempnam(dirname($target), "tmp");
					move_uploaded_file($source, $temp_fname);
					$target = substr($target, $pos1 + strlen($flat_host));
					$result = ftp_put($conn_id, $target, $temp_fname, FTP_BINARY);
					ftp_chmod($conn_id, 511, $target);
					unlink($temp_fname);
				}
				else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Could not resolve ftp target filename. Check the domain in 'ftpinfo' attribute.", "inline-upload").'</strong></font>';
			}
			else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Invalid ftp information. Check 'ftpinfo' attribute.", "inline-upload").'</strong></font>';
			ftp_quit($conn_id);
		}
		else if ( $adminmessages ) echo '<font color="red"><strong>'.'<br />'.__("Could not extract ftp information from 'ftpinfo' attribute. Check its syntax.", "inline-upload").'</strong></font>';
		return $result;
	}		
}

//use wp_specialchars_decode so html is treated as html and not text
//use wp_specialchars when outputting text to ensure it is valid html
function inline_upload_function($incomingfromhandler) {
	$upload_id = wp_specialchars_decode($incomingfromhandler["uploadid"]);
	$upload_title = wp_specialchars_decode($incomingfromhandler["uploadtitle"]);
	$select_button = wp_specialchars_decode($incomingfromhandler["selectbutton"]);
	$upload_button = wp_specialchars_decode($incomingfromhandler["uploadbutton"]);
	$upload_wp_role = wp_specialchars_decode($incomingfromhandler["uploadrole"]);
	$upload_path = wp_specialchars_decode($incomingfromhandler["uploadpath"]);
	$create_path = wp_specialchars_decode($incomingfromhandler["createpath"]);
	$upload_patterns = wp_specialchars_decode($incomingfromhandler["uploadpatterns"]);
	$allowed_patterns = explode(",",$upload_patterns);
	$upload_max_size = wp_specialchars_decode($incomingfromhandler["maxsize"]);
	$access_method = wp_specialchars_decode($incomingfromhandler["accessmethod"]);
	$ftp_info = wp_specialchars_decode($incomingfromhandler["ftpinfo"]);
	$dublicates_policy = wp_specialchars_decode($incomingfromhandler["dublicatespolicy"]);
	$unique_pattern = wp_specialchars_decode($incomingfromhandler["uniquepattern"]);
	$filebase_link = wp_specialchars_decode($incomingfromhandler["filebaselink"]);
	$notify = wp_specialchars_decode($incomingfromhandler["notify"]);
	$notifyrecipients = wp_specialchars_decode($incomingfromhandler["notifyrecipients"]);
	$notifysubject = wp_specialchars_decode($incomingfromhandler["notifysubject"]);
	$notifymessage = wp_specialchars_decode($incomingfromhandler["notifymessage"]);
	$attachfile = wp_specialchars_decode($incomingfromhandler["attachfile"]);
	$redirect = wp_specialchars_decode($incomingfromhandler["redirect"]);
	$redirect_link = wp_specialchars_decode($incomingfromhandler["redirectlink"]);
	$admin_messages = wp_specialchars_decode($incomingfromhandler["adminmessages"]);
	$success_message = wp_specialchars_decode($incomingfromhandler["successmessage"]);
	$success_message_color = wp_specialchars_decode($incomingfromhandler["successmessagecolor"]);

	$uploadedfile = 'uploadedfile_'.$upload_id;
	$upfile = 'upfile_'.$upload_id;
	$upload = 'upload_'.$upload_id;
	$textfile = 'fileName_'.$upload_id;
	$input = 'input_'.$upload_id;
	$user = wp_get_current_user();

	if ( !empty( $user->roles ) && is_array( $user->roles ) ) {
		/* Go through the array of the roles of the current user */
		foreach ( $user->roles as $plugin_upload_role )
		/* If one role of the current user matches to the role allowed to upload */
		if ( $plugin_upload_role == $upload_wp_role || $plugin_upload_role == 'administrator' ) {
			/*  We affect this role to current user */
			$plugin_upload_user_role = $plugin_upload_role;
			break;
		}
		else {
			/* We affect the 'visitor' role to current user */
			$plugin_upload_user_role = 'visitor';
		}
	}
	else {
		$plugin_upload_user_role = 'visitor';
	}		

	if ( $plugin_upload_user_role != $upload_wp_role && $plugin_upload_user_role != 'administrator' && $upload_wp_role != 'all' ) {
		return;
	}		

	$admin_messages = ( $admin_messages == "true" && $plugin_upload_user_role == 'administrator' );

	/* Display the title if one was input. */
	if ( $upload_title ) {
		$inline_upload_output .= '<p style="margin-bottom: 0px;">'.$upload_title.'</p>';
	}

/*	$inline_upload_output .= '<ul>';  
	$inline_upload_output .= "\n\t".'<form name="form_upload" method="post" enctype="multipart/form-data">';		
	$inline_upload_output .= "\n\t\t".'<input type="file" name="'.$uploadedfile.'" id="'.$upfile.'" size="20" tabindex="1" />';
	$inline_upload_output .= "\n\t\t".'<input align="center" type="submit" name="'.$upload.'" value="Upload File" />';
	$inline_upload_output .= "\n\t".'</form>';
	$inline_upload_output .= '</ul>';*/

	$inline_upload_output .= '<p style="height: 1px; padding: 0px; margin: 0px; line-height: 0px;"></p>';
	$inline_upload_output .= "\n".'<input type="text" id="'.$textfile.'" class="file_input_textbox" readonly="readonly"/>';		
	$inline_upload_output .= "\n".'<div class="file_input_div">';  
	$inline_upload_output .= "\n\t".'<form name="form_upload" method="post" enctype="multipart/form-data">';		
	$inline_upload_output .= "\n\t\t".'<input align="center" type="button" id="'.$input.'" value="'.$select_button.'" class="file_input_button"/>';
	$inline_upload_output .= "\n\t\t".'<input type="file" class="file_input_hidden" name="'.$uploadedfile.'" id="'.$upfile.'" tabindex="1" onchange="javascript: document.getElementById(\''.$textfile.'\').value = this.value.replace(/c:\\\\fakepath\\\\/i, \'\')" onmouseout="javascript: document.getElementById(\''.$input.'\').className = \'file_input_button\'" onmouseover="javascript: document.getElementById(\''.$input.'\').className = \'file_input_button_hover\'"/>';
	$inline_upload_output .= "\n\t\t".'<input align="center" type="submit" name="'.$upload.'" value="'.$upload_button.'" class="file_input_submit" />';
	$inline_upload_output .= "\n\t".'</form>';
	$inline_upload_output .= "\n".'</div>'; 
	$inline_upload_output .= '<p style="height: 1px; padding: 0px; margin: 0px; line-height: 0px;"></p>';


	/* Define dynamic upload path from variables */
	$search = array ('/%username%/');	 
	$replace = array ($user->user_login);
	$upload_path =  preg_replace($search, $replace, $upload_path);

	$upload_path_ok = false;
	$allowed_file_ok = false;
	$size_file_ok = false;

	/* Get uploaded file size in Mbytes */
	$upload_file_size = filesize($_FILES[$uploadedfile]['tmp_name']) / 1024 /1024;

	if ( $upload_file_size > 0 ) {

		/* Check if upload path exist */
		if ( is_dir( upload_plugin_full_path($upload_path) ) ) {		
			$upload_path_ok = true;
		}
		else if ( $create_path == "true" ) {
			create_directory(upload_plugin_full_path($upload_path), $access_method, $ftp_info, $admin_messages);
			if ( is_dir( upload_plugin_full_path($upload_path) ) ) {		
				$upload_path_ok = true;
			}
		}

		/* File name control */
		foreach ($allowed_patterns as $allowed_pattern) {
			if ( upload_plugin_wildcard_match( $allowed_pattern, $_FILES[$uploadedfile]['name']) ) {
				$allowed_file_ok = true;
				break ;
			}
		}

		/* File size control */
		if ( $upload_file_size <= $upload_max_size ) {
			$size_file_ok = true;
		}
	
		if ( !$upload_path_ok or !$allowed_file_ok or !$size_file_ok ) {
			$inline_upload_output .=  '<font color="red"><strong>'.__("Upload failed !", "inline-upload").'</strong></font>';
		
			if ( !$upload_path_ok ) {
				$inline_upload_output .=  '<font color="red"><strong>'.'<br />'.__("Targer folder ", "inline-upload").upload_plugin_full_path($upload_path).__(" doesn't exist !", "inline-upload").'</strong></font>';
			}
		
			if ( !$allowed_file_ok ) {
				$inline_upload_output .=  '<font color="red"><strong>'.'<br />'.__("File not allowed", "inline-upload").'</strong></font>';
			}

			if ( !$size_file_ok ) {
				$inline_upload_output .=  '<font color="red"><strong>'.'<br />'.__("File size : ", "inline-upload").$upload_max_size.' Mb</strong></font>';
			}
		}
	}	

	if ( $upload_path_ok and $allowed_file_ok and $size_file_ok ) {

		if ( is_uploaded_file($_FILES[$uploadedfile]['tmp_name']) ) {
	
			if ( $allowed_file_ok and $size_file_ok ) {
				$file_copied = false;
				$message_processed = false;
				$source_path = $_FILES[$uploadedfile]['tmp_name'];
				$only_filename = upload_plugin_clean( $_FILES[$uploadedfile]['name'] );
				$target_path = upload_plugin_full_path($upload_path).$only_filename;

				$search = array ('/%filename%/', '/%filepath%/');	 
				$replace = array ($only_filename, $target_path);
				$success_message =  preg_replace($search, $replace, $success_message);

				if ($source_path) {
					$file_exists = file_exists($target_path);
					if ( !$file_exists || $dublicates_policy == "" || $dublicates_policy == "overwrite" ) {
						$file_copied = upload_file($source_path, $target_path, $access_method, $ftp_info, $admin_messages);
					}
					else if ( $file_exists && $dublicates_policy == "maintain both" ) {
						$full_path = upload_plugin_full_path($upload_path);
						$name_part = $only_filename;
						$ext_part = "";
						$dot_pos = strrpos($name_part, ".");
						if ( $dot_pos ) {
							$ext_part = substr($name_part, $dot_pos);
							$name_part = substr($name_part, 0, $dot_pos);
						}
						if ( $unique_pattern != "datetimestamp" ) {
							$unique_id = 1;
							do {
								$unique_id += 1;
								$only_filename = $name_part . "(" . $unique_id . ")" . $ext_part;
								$target_path = $full_path . $only_filename;
							}
							while ( file_exists($target_path) );
						}
						else {
							$current_datetime = gmdate("U") - 1;
							do {
								$current_datetime += 1;
								$only_filename = $name_part . "-" . gmdate("YmdHis", $current_datetime) . $ext_part;
								$target_path = $full_path . $only_filename;
							}
							while ( file_exists($target_path) );
						}
						$file_copied = upload_file($source_path, $target_path, $access_method, $ftp_info, $admin_messages);
						if ( $file_copied ) {
							$inline_upload_output .= '<font color="'.$success_message_color.'"><strong>'.$success_message.'</strong></font>';
							$message_processed = true;
						}
					}
					else {
						$inline_upload_output .=  '<font color="red"><strong>'.__("Upload skipped! File already exists.", "inline-upload").'</strong></font>';
						$message_processed = true;
						$file_copied = false;
					}
				}

//				echo ABSPATH.'<br />';
//				echo $_SERVER['HTTP_HOST'].'<br />';
//				echo preg_replace("/^(.*\.)?([^.]*\..*)$/", "$2", 'nanopolytox.eu');

				if ( $file_copied ) {
					if ( $filebase_link == "true" ) {			
						$filebaseurl = WP_SITEURL;
						if ( substr($filebaseurl, -1, 1) == "/" ) $filebaseurl = substr($filebaseurl, 0, strlen($filebaseurl) - 1);
						$filebaseurl .= "/wp-admin/tools.php?page=wpfilebase&action=sync&hash_sync=1";					
						echo "<script language=javascript>RunHttpRequest('" . $filebaseurl . "')</script>"; 
					} 
	
					if ( $notify == "true" && $notifyrecipients != "" ) {				
						$search = array ('/%username%/', '/%filename%/', '/%filepath%/');	 
						$replace = array ($user->user_login, $only_filename, $target_path);
						$notifysubject =  preg_replace($search, $replace, $notifysubject);
						$notifymessage =  preg_replace($search, $replace, $notifymessage);
						if ( $attachfile == "true" ) {
							$attachments = array ($target_path);
							wp_mail($notifyrecipients, $notifysubject, $notifymessage, '', $attachments); 
						}
						else {
							wp_mail($notifyrecipients, $notifysubject, $notifymessage); 
						}
					} 

					if ( $redirect == "true" && $redirect_link != "" ) {
						echo "<script language=javascript>Redirect('" . $redirect_link . "')</script>"; 
					}
					else if ( !$message_processed ) {
						$inline_upload_output .= '<font color="'.$success_message_color.'"><strong>'.$success_message.'</strong></font>';
					}
				}
				else if ( !$message_processed ) {
					$inline_upload_output .=  '<font color="red"><strong>'.__("Upload failed ! Unknown error.", "inline-upload").'</strong></font>';
				}

				/* Delete temporary file (in "/xampp/tmp/") */
//				unlink($source_path);			
			}
		}
		else {
			$inline_upload_output .=  '<font color="red"><strong>'.__("Upload failed ! Unknown error.", "inline-upload").'</strong></font>';
		}
	}

  $inline_upload_output .= "\n";

  return $inline_upload_output;
}
?>
